package net.sf.j2s.hello;

import java.io.UnsupportedEncodingException;


public class HelloBase64 {

	public static void main(String[] args) throws UnsupportedEncodingException {
		System.out.println("testHello");
		System.out.println("===========");
		testHello();
		System.out.println("*");
		System.out.println();
		
		System.out.println("testLongString");
		System.out.println("===========");
		testLongString();
		System.out.println("*");
		System.out.println();
		
		System.out.println("testChinese");
		System.out.println("===========");
		testChinese();
		System.out.println("*");
		System.out.println();
		
		System.out.println("testChineseUTF8");
		System.out.println("===========");
		testChineseUTF8();
		System.out.println("*");
		System.out.println();
	}
	
	public static void testHello() {
		String s = "Hello J2S World";
		System.out.println(s);
		String b64 = MyBase64.byteArrayToBase64(s.getBytes());
		System.out.println(b64);
		byte[] bytes = MyBase64.base64ToByteArray(b64);
		String ss = new String(bytes);
		System.out.println(ss);
	}

	public static void testLongString() {
		String s = "J2S provides a way of translating Java codes into JavaScript. Lots of Java codes (such as algorithms library or UI widgets library) can be reused in JavaScript through J2S.";
		System.out.println(s);
		String b64 = MyBase64.byteArrayToBase64(s.getBytes());
		System.out.println(b64);
		byte[] bytes = MyBase64.base64ToByteArray(b64);
		String ss = new String(bytes);
		System.out.println(ss);
	}

	public static void testChinese() {
		String s = "J2SĿּڸеJava룬ĿǰṩJavaֱתɿеJavaScriptÿṩJavaScriptģJava̳йϵAPIͬʱṩjava.util.*org.eclipse.swt.*APIת";
		System.out.println(s);
		String b64 = MyBase64.byteArrayToBase64(s.getBytes());
		System.out.println(b64);
		byte[] bytes = MyBase64.base64ToByteArray(b64);
		String ss = new String(bytes);
		System.out.println(ss);
	}

	public static void testChineseUTF8() throws UnsupportedEncodingException {
		String s = "J2SĿּڸеJava룬ĿǰṩJavaֱתɿеJavaScriptÿṩJavaScriptģJava̳йϵAPIͬʱṩjava.util.*org.eclipse.swt.*APIת";
		System.out.println(s);
		String b64 = MyBase64.byteArrayToBase64(s.getBytes("utf-8"));
		System.out.println(b64);
		byte[] bytes = MyBase64.base64ToByteArray(b64);
		String ss = new String(bytes, "utf-8");
		System.out.println(ss);
	}

}
