package net.sf.j2s.hello;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class HelloUserAndPets {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// users
		J2SUser josson = new J2SUser("josson", null, 24, ISex.MALE);
		josson.setEmail("josson@smith");
		//System.out.println(josson);

		J2SUser kelly = new J2SUser("kelly");
		kelly.setSex(ISex.FEMALE);
		//System.out.println(kelly);

		J2SDog bb = new J2SDog("baibai", 24);
		bb.setColor("black");
		//System.out.println(bb);

		J2SDog ww = new J2SDog("wangwang");
		ww.setSex(ISex.FEMALE);
		//System.out.println(ww);

		J2SDog dd = new J2SDog("digdig", 24, "yellow");
		dd.setSex(ISex.FEMALE);
		//System.out.println(dd);

		Relation unps1 = new Relation(josson);
		unps1.addPet(bb);
		unps1.addPet(dd);
		System.out.println("Relationship 1:");
		System.out.println(unps1);

		Relation unps2 = new Relation(kelly);
		unps2.addPet(bb);
		unps2.addPet(ww);
		System.out.println("Relationship 1:");
		System.out.println(unps2);

		System.out.println("Trying to find out who is the common pet:");
		List jossonPets = unps1.getPets();
		List kellyPets = unps2.getPets();
		for (Iterator iter = jossonPets.iterator(); iter.hasNext();) {
			J2SPet pet = (J2SPet) iter.next();
			if (kellyPets.contains(pet)) {
				System.out.println("Pet " + pet.getName()
						+ " is owned by both " + josson.getName() + " and "
						+ kelly.getName());
			}
		}
		System.out.println();
		
		Set petSet = new HashSet();
		petSet.addAll(jossonPets);
		petSet.addAll(kellyPets);
		System.out.println("In total, there are " + petSet.size() + " pets:");
		for (Iterator iter = petSet.iterator(); iter.hasNext();) {
			J2SPet pet = (J2SPet) iter.next();
			System.out.println(pet);
		}
	}

}
