package net.sf.j2s.hello;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Relation {
	private J2SUser user;
	private List pets;
	
	private Relation() {
		// prevent instantialization from Java codes
	}

	public Relation(J2SUser user) {
		super();
		this.user = user;
		this.pets = new ArrayList();
	}
	
	public void addPet(J2SPet pet) {
		pets.add(pet);
	}
	
	public List getPets() {
		return pets;
	}
	
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append("Description of owner:\r\n");
		buffer.append(user);
		buffer.append("\r\n");
		buffer.append("About ");
		buffer.append(user.getAdjective());
		buffer.append(' ');
		buffer.append(pets.size());
		buffer.append(" pets:\r\n");
		for (Iterator iter = pets.iterator(); iter.hasNext();) {
			J2SPet pet = (J2SPet) iter.next();
			buffer.append(pet);
			buffer.append("\r\n");
		}
		return buffer.toString();
	}
}
